Index: palm/trunk/SCRIPTS/batch_scp
===================================================================
--- palm/trunk/SCRIPTS/batch_scp	(revision 65)
+++ palm/trunk/SCRIPTS/batch_scp	(revision 66)
@@ -1,5 +1,5 @@
 #! /bin/ksh
 # batch_scp - Shellskript         Version:  @(#)batch_scp 1.0a     25/10/05
-# $Id$
+# $Id: batch_scp 54 2007-03-08 00:00:02Z raasch $
 
      # Prozedur zum automatischen Transfer von Dateien mittels scp
Index: palm/trunk/SCRIPTS/mbuild
===================================================================
--- palm/trunk/SCRIPTS/mbuild	(revision 65)
+++ palm/trunk/SCRIPTS/mbuild	(revision 66)
@@ -1,5 +1,5 @@
 #!/bin/ksh
-# mbuild - Programmuebersetzungsscript   Version:  @(#)MBUILD 2.0    08/03/07
-# $Id$
+# mbuild - Programmuebersetzungsscript
+# $Id: mbuild 54 2007-03-08 00:00:02Z raasch $
 
      # Prozedur zur Uebersetzung von Programmteilen mittels make-Mechanismus
@@ -82,4 +82,6 @@
      # 02/03/07 - Siggi - compilation of utility programs and transfer of
      #                    scripts to remote hosts added (option -u)
+     # 14/03/07 - Siggi - fimm admitted, revision number added to terminal
+     #                    output
 
 
@@ -102,9 +104,9 @@
  typeset -i  ih ihost=0
 
- typeset  -R50 calltime
+ typeset  -R30 calltime
  typeset  -L20 column1
  typeset  -L50 column2
  typeset  -L70 column3
- typeset  -L20 version="MBUILD  2.0"
+ typeset  -L40 version="MBUILD  2.0  $Rev$"
 
     # FEHLERBEHANDLUNG
@@ -158,4 +160,5 @@
      (berte)                    local_host=t3eb;;
      (bora|breva|gregale|irifi|levanto|maestro|orkan|ostria|quanero|scirocco)  local_host=lcmuk;;
+     (fimm.bccs.uib.no)         local_host=lcmuk;;
      (gate)                     local_host=neck;;
      (gfdl3.yonsei.ac.kr)       local_host=decalpha; local_addres=165.132.26.56;;
Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 65)
+++ palm/trunk/SCRIPTS/mrun	(revision 66)
@@ -3,6 +3,6 @@
 ##!/home/DSRC/NC/tatuyama/pub/ksh   NEEDED ON NEC AT RIAM !!!!!!!!!!
 
-# mrun - Plot-Shellskript         Version:  @(#)MRUN 2.0   07/03/07
-# $Id$
+# mrun - Plot-Shellskript
+# $Id: mrun 61 2007-03-12 05:42:06Z raasch $
 
      # Prozedur zum Starten von Modellaeufen
@@ -112,4 +112,6 @@
      #                     mrun_path replaced by PALM_BIN,
      #                     all machines are calling interpret_config.x
+     # 14/03/07 - Siggi  - fimm admitted, revision number added to terminal
+     #                     output
 
 
@@ -218,5 +220,5 @@
  typeset -i  cputime i ii icycle inode ival jobges jobsek maxcycle minuten nodes pes sekunden tp1
 
- typeset  -R40 calltime
+ typeset  -R30 calltime
  typeset  -L20 spalte1
  typeset  -L40 spalte2
@@ -227,5 +229,5 @@
  typeset  -L12 string4
  typeset  -L12 string5
- typeset  -L20 version="MRUN  2.0"
+ typeset  -L30 version="MRUN  2.0 $Rev$"
 
 
@@ -332,5 +334,6 @@
      (breg*-en0|berni*-en0) localhost=ibmb; archive_system=tivoli;;
      (cs*)                  localhost=nech; archive_system=ut;;
-     (gate|n-sx)            PATH=$MRUN_BIN:$PATH:/usr/bin/nqsII; localhost=neck;;
+     (fimm.bccs.uib.no)     local_host=lcmuk;;
+     (gate|n-sx)            PATH=$PALM_BIN:$PATH:/usr/bin/nqsII; localhost=neck;;
      (ground.yonsei.ac.kr)  localhost=decalpha;;
      (gfdl3.yonsei.ac.kr)   localhost=decalpha;;
@@ -763,5 +766,10 @@
 #    esac
 
-    interpret_config.x
+    if [[ $localhost_realname = "gate" ]]
+    then
+       interpret_config_gate.x
+    else
+       interpret_config.x
+    fi
 
        # AUSFUEHRUNG DER GENERIERTEN SHELL-KOMMANDOS IN DIESER SHELL
@@ -3852,5 +3860,9 @@
     echo  "export LOCAL_MRUN_PATH"                      >>  $jobfile
 
-#    echo  "for_subjob_to_do=\"rm -rf  $TEMPDIR\" "      >>  $jobfile
+       # WORKAROUND FUER RIAM-NEC-JOBS WEGEN PROFILE-SCHWIERIGKEITEN
+    if [[ $localhost_realname = "gate" ]]
+    then
+       echo  "export PALM_BIN=$PALM_BIN"                >>  $jobfile
+    fi
 
        # MRUN AUF ZIELRECHNER AUFRUFEN
Index: palm/trunk/SCRIPTS/subjob
===================================================================
--- palm/trunk/SCRIPTS/subjob	(revision 65)
+++ palm/trunk/SCRIPTS/subjob	(revision 66)
@@ -1,5 +1,5 @@
 #!/bin/ksh
 # subjob - Plot-Shellskript         Version:  @(#)SUBJOB 1.0    13/02/07
-# $Id$
+# $Id: subjob 54 2007-03-08 00:00:02Z raasch $
 
      # Prozedur zum automatischen Generieren von Batch-Jobs, die unter NQS