Index: palm/trunk/SCRIPTS/mbuild
===================================================================
--- palm/trunk/SCRIPTS/mbuild	(revision 68)
+++ palm/trunk/SCRIPTS/mbuild	(revision 69)
@@ -84,4 +84,7 @@
      # 14/03/07 - Siggi - fimm admitted, revision number added to terminal
      #                    output
+     # 16/03/07 - Siggi - adjustments (netcdf) for lctit
+     #                    adjustments for running under pdksh, local ip-addres
+     #                    is not determined any more
 
 
@@ -113,5 +116,6 @@
     # FEHLERBEHANDLUNG
     # BEI EXIT:
- trap 'if [[ $locat != normal ]]
+ trap 'rm -rf  tmp_mbuild
+       if [[ $locat != normal ]]
        then
           printf "\n\n +++ mbuild killed \n\n"
@@ -122,5 +126,6 @@
 
     # BEI TERMINAL-BREAK:
- trap 'printf "\n\n +++ mbuild killed by \"^C\" \n\n"
+ trap 'rm -rf  tmp_mbuild
+       printf "\n\n +++ mbuild killed by \"^C\" \n\n"
        exit
       ' 2
@@ -156,5 +161,6 @@
     # LOKALEN RECHNER ERMITTELN
  local_host_real_name=$(hostname)
- local_addres=$(nslookup `hostname` 2>&1 | grep "Address:" | tail -1 | awk '{print $2}')
+# local_addres=$(nslookup `hostname` 2>&1 | grep "Address:" | tail -1 | awk '{print $2}')
+
  case  $local_host_real_name  in
      (atmos)                    local_host=lcide;;
@@ -163,6 +169,6 @@
      (fimm.bccs.uib.no)         local_host=lcmuk;;
      (gate)                     local_host=neck;;
-     (gfdl3.yonsei.ac.kr)       local_host=decalpha; local_addres=165.132.26.56;;
-     (gfdl5)                    local_host=ibmy; local_addres=165.132.26.58;;
+     (gfdl3.yonsei.ac.kr)       local_host=decalpha;;
+     (gfdl5)                    local_host=ibmy;;
      (gwdk081.gwdg.de)          local_host=ibm;;
      (hreg01a-en0|hreg02a-en0)  local_host=ibmh;;
@@ -200,5 +206,6 @@
     # BENUTZERNAMEN AUF LOKALEM RECHNER AUS KONFIGURATIONSDATEI ERMITTELN
  line=""
- grep  " $local_host" $config_file | grep "%remote_username"  |  while read line
+ grep  " $local_host" $config_file | grep "%remote_username"  >  tmp_mbuild
+ while read line
  do
     if [[ "$line" != ""  ||  $(echo $line | cut -c1) != "#" ]]
@@ -206,5 +213,5 @@
        local_username=`echo $line | cut -d" " -s -f2`
     fi
- done
+ done < tmp_mbuild
 
  if [[ "$local_username" = "" ]]
@@ -222,5 +229,6 @@
     # VARIABLEN SETZEN, WEIL DIESE EVTL. IN PFADNAMEN VERWENDET WERDEN
  line=""
- grep "%" $config_file  |  while read line
+ grep "%" $config_file  >  tmp_mbuild
+ while read line
  do
     if [[ "$line" != ""  &&  "$(echo $line | cut -d" " -s -f3)" = "" ]]
@@ -231,9 +239,10 @@
 #       eval echo \"   $var=\$$var \"   # AUSGABE ZU TESTZWECKEN
     fi
- done
+ done < tmp_mbuild
 
     # NUN PRUEFEN, OB EIN GLOBALER QUELLTEXTPFAD VEREINBART WURDE
  line=""
- grep "%source_path" $config_file  |  while read line
+ grep "%source_path" $config_file  >  tmp_mbuild
+ while read line
  do
     if [[ "$line" != ""  &&  $(echo $line | cut -c1) != "#" ]]
@@ -244,8 +253,9 @@
        fi
     fi
- done
+ done < tmp_mbuild
 
  line=""
- grep  " $local_host" $config_file | grep "%source_path"  |  while read line
+ grep  " $local_host" $config_file | grep "%source_path"  >  tmp_mbuild
+ while read line
  do
     if [[ "$line" != ""  &&  $(echo $line | cut -c1) != "#" ]]
@@ -253,5 +263,5 @@
        local_source_path=`echo $line | cut -d" " -s -f2`
     fi
- done
+ done < tmp_mbuild
 
  if [[ "$local_source_path" = "" ]]
@@ -273,5 +283,6 @@
      # EBENSO PFAD FUER DAS MAKE-DEPOSITORY ERMITTELN
  line=""
- grep "%depository_path" $config_file  |  while read line
+ grep "%depository_path" $config_file  >  tmp_mbuild
+ while read line
  do
     if [[ "$line" != ""  &&  $(echo $line | cut -c1) != "#" ]]
@@ -282,8 +293,9 @@
        fi
     fi
- done
+ done < tmp_mbuild
 
  line=""
- grep  " $local_host" $config_file | grep "%depository_path"  |  while read line
+ grep  " $local_host" $config_file | grep "%depository_path"  >  tmp_mbuild
+ while read line
  do
     if [[ "$line" != ""  &&  $(echo $line | cut -c1) != "#" ]]
@@ -291,5 +303,5 @@
        local_depository_path=`echo $line | cut -d" " -s -f2`
     fi
- done
+ done < tmp_mbuild
 
  if [[ "$local_depository_path" = "" ]]
@@ -628,5 +640,6 @@
  printf "\n  *** scanning configuration file for host(s) ..."
 
- grep  %fopts  $config_file  |  while read line
+ grep  %fopts  $config_file  >  tmp_mbuild
+ while read line
  do
        # KOMMENTARZEILEN UEBERSPRINGEN
@@ -634,5 +647,5 @@
     (( ihost = ihost + 1 ))
     hostline[$ihost]="$line"
- done
+ done < tmp_mbuild
 
  
@@ -699,5 +712,5 @@
                          fi;;
         (lctit)          remote_addres=172.17.75.161; netcdf_support=true
-                         netcdf_path=/home/usr5/mkanda/netcdf-3.6.1/src; cpp_options="-Mpreprocess";;
+                         netcdf_path=/home/usr5/mkanda/netcdf-3.6.2; cpp_options="-Mpreprocess";;
         (decalpha)       remote_addres=165.132.26.56; cpp_options="-cpp"; netcdf_support=true
                          netcdf_path=/usr/local/netcdf-3.5.1;;
@@ -728,5 +741,6 @@
        # REMOTE-USERNAMEN ERMITTELN
     line=""
-    grep  "$remote_host_string" $config_file | grep "%remote_username"  |  while read line1
+    grep  "$remote_host_string" $config_file | grep "%remote_username"  >  tmp_mbuild
+    while read line1
     do
        if [[ $(echo $line1 | cut -d" " -s -f3-) = "$remote_host_string" ]]
@@ -734,5 +748,5 @@
           line="$line1"
        fi
-    done
+    done < tmp_mbuild
 
     if [[ "$line" = ""  ||  $(echo $line | cut -c1) = "#" ]]
@@ -749,5 +763,6 @@
     line=""
     remote_source_path=""
-    grep  "$remote_host_string" $config_file | grep "%source_path"  |  while read line1
+    grep  "$remote_host_string" $config_file | grep "%source_path"  >  tmp_mbuild
+    while read line1
     do
        if [[ $(echo $line1 | cut -d" " -s -f3-) = "$remote_host_string" ]]
@@ -755,5 +770,5 @@
           line="$line1"
        fi
-    done
+    done < tmp_mbuild
 
     if [[ "$line" != ""  &&  $(echo $line | cut -c1) != "#" ]]
@@ -780,5 +795,6 @@
     remote_md=""
     line=""
-    grep  "$remote_host_string" $config_file | grep "%depository_path"  |  while read line1
+    grep  "$remote_host_string" $config_file | grep "%depository_path"  >  tmp_mbuild
+    while read line1
     do
        if [[ $(echo $line1 | cut -d" " -s -f3-) = "$remote_host_string" ]]
@@ -786,5 +802,5 @@
           line="$line1"
        fi
-    done
+    done < tmp_mbuild
 
     if [[ "$line" != ""  &&  $(echo $line | cut -c1) != "#" ]]
@@ -810,5 +826,6 @@
        # COMPILERNAMEN ERMITTELN
     line=""
-    grep  "$remote_host_string" $config_file | grep "%compiler_name "  |  while read line1
+    grep  "$remote_host_string" $config_file | grep "%compiler_name "  >  tmp_mbuild
+    while read line1
     do
        if [[ $(echo $line1 | cut -d" " -s -f3-) = "$remote_host_string" ]]
@@ -816,5 +833,5 @@
           line="$line1"
        fi
-    done
+    done < tmp_mbuild
 
     if [[ "$line" = ""  ||  $(echo $line | cut -c1) = "#" ]]
@@ -833,5 +850,6 @@
     then
        line=""
-       grep  "$remote_host_string" $config_file | grep "%compiler_name_ser"  |  while read line1
+       grep  "$remote_host_string" $config_file | grep "%compiler_name_ser"  >  tmp_mbuild
+       while read line1
        do
           if [[ $(echo $line1 | cut -d" " -s -f3-) = "$remote_host_string" ]]
@@ -839,5 +857,5 @@
              line="$line1"
           fi
-       done
+       done < tmp_mbuild
 
        if [[ "$line" = ""  ||  $(echo $line | cut -c1) = "#" ]]
@@ -923,5 +941,6 @@
        # COMPILEROPTIONEN ERMITTELN
     line=""
-    grep  "$remote_host_string" $config_file | grep "%fopts"  |  while read line1
+    grep  "$remote_host_string" $config_file | grep "%fopts"  >  tmp_mbuild
+    while read line1
     do
        if [[ $(echo $line1 | cut -d" " -s -f3-) = "$remote_host_string" ]]
@@ -929,5 +948,5 @@
           line="$line1"
        fi
-    done
+    done < tmp_mbuild
     if [[ "$line" = ""  ||  $(echo $line | cut -c1) = "#" ]]
     then
@@ -947,5 +966,5 @@
           (ibmy)      compiler_options="-I ${netcdf_path}/include  $compiler_options";;
           (lcmuk)     compiler_options="-I ${netcdf_path}/include  $compiler_options";;
-          (lctit)     compiler_options="-I ${netcdf_path}/f90      $compiler_options";;
+          (lctit)     compiler_options="-I ${netcdf_path}/include  $compiler_options";;
           (nech|neck) compiler_options="-I ${netcdf_path}/include  $compiler_options";;
        esac
@@ -956,5 +975,6 @@
        # LADER-OPTIONEN ERMITTELN
     line=""
-    grep  "$remote_host_string" $config_file | grep "%lopts"  |  while read line1
+    grep  "$remote_host_string" $config_file | grep "%lopts"  >  tmp_mbuild
+    while read line1
     do
        if [[ $(echo $line1 | cut -d" " -s -f3-) = "$remote_host_string" ]]
@@ -962,5 +982,5 @@
           line="$line1"
        fi
-    done
+    done < tmp_mbuild
 
     if [[ "$line" = ""  ||  $(echo $line | cut -c1) = "#" ]]
@@ -980,5 +1000,5 @@
           (ibms)                       loader_options="$loader_options -L${netcdf_path} -lnetcdf";;
           (ibmy)                       loader_options="$loader_options -L${netcdf_path}/lib -lnetcdf";;
-          (lctit)                      loader_options="$loader_options -L${netcdf_path}/libsrc -lnetcdf";;
+          (lctit)                      loader_options="$loader_options -L${netcdf_path}/lib -lnetcdf";;
        esac
     fi
Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 68)
+++ palm/trunk/SCRIPTS/mrun	(revision 69)
@@ -1,3 +1,3 @@
-#!/bin/ksh
+#!/bin/pdksh
 
 ##!/home/DSRC/NC/tatuyama/pub/ksh   NEEDED ON NEC AT RIAM !!!!!!!!!!
@@ -114,4 +114,5 @@
      # 14/03/07 - Siggi  - fimm admitted, revision number added to terminal
      #                     output
+     # 16/03/07 - Siggi  - adjustments for lctit
 
 
@@ -184,5 +185,6 @@
  read_from_config=""
  restart_run=false
- return_addres=$(nslookup `hostname` 2>&1 | grep "Address:" | tail -1 | awk '{print $2}')
+# return_addres=$(nslookup `hostname` 2>&1 | grep "Address:" | tail -1 | awk '{print $2}')
+ return_addres=1.2.3.4
  if [[ $return_addres = 130.75.105.158 ]]
  then
@@ -246,5 +248,6 @@
     # FEHLERBEHANDLUNG
     # BEI EXIT:
- trap 'if [[ $locat != localhost ]]
+ trap 'rm -rf  tmp_mrun
+       if [[ $locat != localhost ]]
        then
 #          if [[ ! -f ${mrun_path}/statistik/mrun_statistik ]]
@@ -271,5 +274,5 @@
 #             fi
 #          fi
-          continue
+          echo " " > /dev/null
        fi
 
@@ -308,5 +311,6 @@
 
     # BEI TERMINAL-BREAK:
- trap '[[ $tmpcreate = true ]]  &&  (cd; rm -rf $TEMPDIR)
+ trap 'rm -rf  tmp_mrun
+       [[ $tmpcreate = true ]]  &&  (cd; rm -rf $TEMPDIR)
        if [[ -f ~/job_queue/JOBINFO.$QSUB_REQID ]]
        then
@@ -520,8 +524,8 @@
  if [[ -n $additional_conditions ]]
  then
-    echo $additional_conditions | cut -d" " -f1-3 | read  cond1  cond2  dummy
-#    cond1=`echo $additional_conditions | cut -d" " -f1`
-#    cond2=`echo $additional_conditions | cut -d" " -s -f2`
-#    dummy=`echo $additional_conditions | cut -d" " -s -f3`
+#    echo $additional_conditions | cut -d" " -f1-3 | read  cond1  cond2  dummy
+    cond1=`echo $additional_conditions | cut -d" " -f1`
+    cond2=`echo $additional_conditions | cut -d" " -s -f2`
+    dummy=`echo $additional_conditions | cut -d" " -s -f3`
     if [[ -n $dummy ]]
     then
@@ -592,10 +596,10 @@
              # ZEILE DEFINIERT ENVIRONMENT-VARIABLE
           zeile=$(echo $zeile | cut -c2-)
-          echo $zeile | cut -d" " -f1-5 | read  var  value  for_host  for_cond1  for_cond2
-#          var=`echo $zeile | cut -d" " -f1`
-#          value=`echo $zeile | cut -d" " -s -f2`
-#          for_host=`echo $zeile | cut -d" " -s -f3`
-#          for_cond1=`echo $zeile | cut -d" " -s -f4`
-#          for_cond2=`echo $zeile | cut -d" " -s -f5`
+#          echo $zeile | cut -d" " -f1-5 | read  var  value  for_host  for_cond1  for_cond2
+          var=`echo $zeile | cut -d" " -f1`
+          value=`echo $zeile | cut -d" " -s -f2`
+          for_host=`echo $zeile | cut -d" " -s -f3`
+          for_cond1=`echo $zeile | cut -d" " -s -f4`
+          for_cond2=`echo $zeile | cut -d" " -s -f5`
 
           if [[ "$for_host" = ""  ||  ( "$for_host" = $host  &&  "$for_cond1" = "$cond1"  &&  "$for_cond2" = "$cond2" )  ||  $(echo "$input_list$output_list"|grep -c "$for_host") != 0 ]]
@@ -683,7 +687,7 @@
              # s2b: loc    - Feld (optional)
              # s2c: tr/ar  - Feld (optional)
-          echo $zeile | cut -d" " -f1-2 | read  s1  s2
-#          s1=`echo $zeile | cut -d" " -f1`
-#          s2=`echo $zeile | cut -d" " -s -f2`
+#          echo $zeile | cut -d" " -f1-2 | read  s1  s2
+          s1=`echo $zeile | cut -d" " -f1`
+          s2=`echo $zeile | cut -d" " -s -f2`
           s2a=$(echo $s2 | cut -d":" -f1)
           if [[ $(echo $s2 | grep -c ":") = 0 ]]
@@ -692,13 +696,13 @@
              s2c=""
           else
-             echo $s2 | cut -d":" -f2-3 | sed 's/:/ /g' | read  s2b  s2c
-#             s2b=`echo $s2 | cut -d":" -f2 | sed 's/:/ /g'`
-#             s2c=`echo $s2 | cut -d":" -s -f3 | sed 's/:/ /g'`
-          fi
-          echo $zeile | cut -d" " -f3-6 | read  s3  s4  s5  s6
-#          s3=`echo $zeile | cut -d" " -f3`
-#          s4=`echo $zeile | cut -d" " -s -f4`
-#          s5=`echo $zeile | cut -d" " -s -f5`
-#          s6=`echo $zeile | cut -d" " -s -f6`
+#             echo $s2 | cut -d":" -f2-3 | sed 's/:/ /g' | read  s2b  s2c
+             s2b=`echo $s2 | cut -d":" -f2 | sed 's/:/ /g'`
+             s2c=`echo $s2 | cut -d":" -s -f3 | sed 's/:/ /g'`
+          fi
+#          echo $zeile | cut -d" " -f3-6 | read  s3  s4  s5  s6
+          s3=`echo $zeile | cut -d" " -f3`
+          s4=`echo $zeile | cut -d" " -s -f4`
+          s5=`echo $zeile | cut -d" " -s -f5`
+          s6=`echo $zeile | cut -d" " -s -f6`
 
        
@@ -768,4 +772,22 @@
 #    esac
 
+
+       # ENVIRONMENT-VARIABLEN FUER INTERPRET_CONFIG UEBER NAMELIST_DATEI ZUR
+       # VERFUEGUNG STELLEN
+    cat  >  .mrun_environment  <<  %%END%%
+ &mrun_environment  cond1 = '$cond1', cond2 = '$cond2', 
+                    config_file = '$config_file', do_remote = '$do_remote',
+                    do_trace = '$do_trace', host = '$host',
+                    input_list = '$input_list', icf = '$interpreted_config_file',
+                    localhost = '$localhost', output_list = '$output_list' /
+
+%%END%%
+
+       # WERTE VON MRUN-OPTIONEN SICHERN UND DAMIT GEGEBENENFALLS SPAETER DIE
+       # IN DER KONFIGURAIONSDATEI ANGEGEBENEN WERTE UEBERSTEUERN
+    mrun_memory=$memory
+    mrun_cpumax=$cpumax
+    mrun_numprocs=$numprocs
+
     if [[ $localhost_realname = "gate" ]]
     then
@@ -779,5 +801,10 @@
     export PATH=$PATH:.
     . $interpreted_config_file
-    rm  $interpreted_config_file
+#    rm  $interpreted_config_file
+
+       # OPTIONSWERTE UEBERSTEUERN KONFIGURATIONSDATEI
+    [[ "mrun_memory"   != "" ]]  &&  memory=$mrun_memory
+    [[ "mrun_cpumax"   != "" ]]  &&  cpumax=$mrun_cpumax
+    [[ "mrun_numprocs" != "" ]]  &&  numprocs=$mrun_numprocs
 
  fi
@@ -1054,5 +1081,5 @@
                   fi;;
      (lctit)      netcdf_support=true
-                  netcdf_path=/home2/usr5/mkanda/netcdf-3.6.1;;
+                  netcdf_path=/home2/usr5/mkanda/netcdf-3.6.2;;
      (nech)       netcdf_support=true
                   netcdf_path=/pool/SX-6/netcdf/netcdf-3.6.0-p1;;
@@ -1391,5 +1418,6 @@
           # ALLE MODIFIZIERTEN QUELLCODEDATEIEN AUFLISTEN
        Filenames=""
-       svn status  |  while  read line
+       svn status  >  tmp_mrun
+       while  read line
        do
           firstc=`echo $line | cut -c1`
@@ -1403,5 +1431,5 @@
              fi
           fi
-       done
+       done < tmp_mrun
 
 
@@ -1869,6 +1897,6 @@
        (lcmuk|nech|neck)  FOPTS="-I ${netcdf_path}/include  $FOPTS"
                           LOPTS="$LOPTS -L${netcdf_path}/lib -lnetcdf";;
-       (lctit)            FOPTS="-I ${netcdf_path}/src/f90  $FOPTS"
-                          LOPTS="$LOPTS -L${netcdf_path}/src/libsrc -lnetcdf";;
+       (lctit)            FOPTS="-I ${netcdf_path}/include  $FOPTS"
+                          LOPTS="$LOPTS -L${netcdf_path}/lib -lnetcdf";;
 
     esac
@@ -2175,5 +2203,6 @@
              # PFADNAMEN FUER DAS MAKE-DEPOSITORY ERMITTELN
           line=""
-          grep "%depository_path" $config_file  |  while read line
+          grep "%depository_path" $config_file  >  tmp_mrun
+          while read line
           do
              if [[ "$line" != ""  &&  $(echo $line | cut -c1) != "#" ]]
@@ -2184,8 +2213,9 @@
                 fi
              fi
-          done
+          done < tmp_mrun
 
           line=""
-          grep  " $localhost" $config_file | grep "%depository_path"  |  while read line
+          grep  " $localhost" $config_file | grep "%depository_path"  >  tmp_mrun
+          while read line
           do
              if [[ "$line" != ""  &&  $(echo $line | cut -c1) != "#" ]]
@@ -2193,5 +2223,5 @@
                 local_depository_path=`echo $line | cut -d" " -s -f2`
              fi
-          done
+          done < tmp_mrun
 
           if [[ "$local_depository_path" = "" ]]
@@ -2915,7 +2945,7 @@
              if [[ "$QUEUE" = interactive ]]
              then
-                mpirun  -np $numprocs  $runfile  $ROPTS  >  aout_output  2>&1
+                mpirun  -np $numprocs  a.out  $ROPTS  >  aout_output  2>&1
              else
-                n1ge  -fore  -mpi $numprocs  -q $queue  $runfile  $ROPTS  >  aout_output  2>&1
+                n1ge  -fore  -mpi $numprocs  -q $queue  a.out  $ROPTS  >  aout_output  2>&1
              fi
 
@@ -3866,5 +3896,5 @@
 
        # WORKAROUND FUER RIAM-NEC-JOBS WEGEN PROFILE-SCHWIERIGKEITEN
-    if [[ $localhost_realname = "gate" ]]
+    if [[ $localhost_realname = "gate"  ||  $localhost = lctit ]]
     then
        echo  "export PALM_BIN=$PALM_BIN"                >>  $jobfile
Index: palm/trunk/SCRIPTS/subjob
===================================================================
--- palm/trunk/SCRIPTS/subjob	(revision 68)
+++ palm/trunk/SCRIPTS/subjob	(revision 69)
@@ -289,5 +289,5 @@
         (ibms)   queue=p_normal; remote_addres=150.183.5.101; submcom=/usr/lpp/LoadL/full/bin/llsubmit;;
         (ibmy)   queue=parallel; remote_addres=165.132.26.58; submcom=/usr/lpp/LoadL/full/bin/llsubmit;;
-        (lctit)  queue=test; remote_addres=172.17.75.161; submcom=/n1ge/TITECH_GRID/tools/bin/n1ge;;
+        (lctit)  queue=default; remote_addres=172.17.75.161; submcom=/n1ge/TITECH_GRID/tools/bin/n1ge;;
         (nech)   qsubmem=memsz_job; qsubtime=cputim_job; remote_addres=136.172.44.147; submcom="/usr/local/bin/qsub";;
         (neck)   qsubmem=memsz_job; qsubtime=cputim_job; remote_addres=133.5.178.11; submcom="/usr/bin/nqsII/qsub";;
@@ -327,5 +327,5 @@
                  esac;;
         (lctit)  case  $ndq  in
-                     (cs|default|high|test)                  error=false;;
+                     (default|high|bes1|bes2|sla1|sla2)      error=false;;
                      (*)                                     error=true;;
                  esac;;
@@ -694,6 +694,6 @@
 #$ -S /bin/bash
 cd $job_catalog
-PATH=$job_catalog:${job_catalog}/../pub:\$PATH
-export PATH
+export PATH=$PALM_BIN:\$PATH
+echo \$PATH
 
 %%END%%
@@ -866,8 +866,14 @@
     # EIGENTLICHE JOB-DATEI AN QSUB-KOMMANDOS ANHAENGEN
  cat  $file_to_send  >>  $job_to_send
+
  if [[ $remote_host = ibm ]]
  then
     echo " "         >>  $job_to_send
     echo "exit"      >>  $job_to_send
+ fi
+ if [[ $remote_host = lctit ]]
+ then
+    echo " "                               >>  $job_to_send
+    echo "rm ~/job_queue/$job_on_remhost"  >>  $job_to_send
  fi
 
@@ -1020,6 +1026,4 @@
           echo "$submcom  $job_on_remhost"
           chmod  u+x  $job_on_remhost
-          sleep 5   # WEIL N1GE IM HINTERGRUND ARBEITET UND DATEI SONST EVTL.
-                    # SCHON WIEDER GELOESCT IST
        elif [[ $local_host = nech ]]
        then
@@ -1033,5 +1037,6 @@
           qsub  $job_on_remhost
        fi
-       rm  $job_on_remhost
+          # JOBFILE DARF AUF LCTIT NICHT GELOESCHT WERDEN!! GESCHIEHT ERST AM JOBENDE
+       [[ $local_host != lctit ]]  &&  rm  $job_on_remhost
        cd  -  > /dev/null
     fi